Codeforces Round 294 (Div. 2)
整理日期按学习顺序编排,不代表原始发表时间。实际整理于 2026-10-23。
难度为阅读建议,可从 ACM 学习索引 按阶段阅读。
Codeforces Round 294 (Div. 2)
C题:有n个老师,m个学生,a方案是1老师和2学生,b方案是2老师和1学生,求最多可以成功达成多少套方案?
Sol:wa了一发贪心,样例怎么全过了?从纯数学的角度去看,就是线性规划,只不过由于参数不确定需要分类讨论,我们只需要设x套a,y套b,求x+y的最大值(在两个总人数的约束条件下。
1 | void solve(){ |
考虑到数据范围很小,官方正解是直接暴力枚举
1 | int main() { |
D:题意:给定一个字符串s,字符集有小写字母,每个小写字母有权值,求有多少个子串满足子串的首尾字母相等并且子串的f_权值为0.
f权值的定义是对于一个子串,去除首字母和尾字母的权值和。
Sol:首先预处理每个字母在哪些位置集合。先考虑简单的问题,假如就是子串的所有字母权值和,我们只需要在同一个字母的位置集合里查询前面有多少位置的前缀和等于这个位置就可以了。
- 但现在需要偏移位置,推前缀和式子发现需要统计的是上一个位置的前缀和的个数,加进去的这个位置的前缀和,0位置的贡献在第一轮被加进去了。
1 | void solve(){ |
E;详情见lca专题
本博客所有文章除特别声明外,均采用 CC BY-NC-SA 4.0 许可协议。转载请注明来源 爱飞鱼的blog!
